# An extension of our main module
#
# @author [brwnrclse]
#
module Reivt
  # An extension of the RevAPI module
  #
  # @author [brwnrclse]
  #
  module RevAPI
    DeleteDocumentMutation = CLIENT.parse <<-'GRAPHQL'
      mutation($id: ID!) {
        deleteDocument(id: $id) {
          id
        }
      }
    GRAPHQL

    # API call to deleteDocument
    # @param id [String] The unique identifier of the Document
    #
    # @return [String, RevAPI::GraphQLValidationError] The id of the deleted
    #                                                    Document or an error
    #
    def self.delete_doc(id)
      if id.length < 25
        raise raise Reivt::GraphQLValidationException, 'Missing id to delete'
      end

      result = CLIENT.query(DeleteDocumentMutation, variables: { id: id })
      data = RevAPI.retrieve(result)

      data.deleteDocument.id
    end
  end
end
