# An extension of our main module
#
# @author [brwnrclse]
#
module Reivt
  # An extension of the RevAPI module
  #
  # @author [brwnrclse]
  #
  module RevAPI
    CreateRevMutation = CLIENT.parse <<-'GRAPHQL'
      mutation($description: String!, $title: String!, $user_id: ID!) {
        createRev(description: $description, title: $title, userId: $user_id) {
          id
        }
      }
    GRAPHQL

    # API call to createRev
    # @param description [String] What the Rev is about
    # @param title [String] The name of the Rev
    #
    # @return [String] The id of the created Rev
    #
    def self.create_rev(description, title)
      description = 'Some rev' if description.nil? || description.strip.empty?
      title = 'A rev, right?' if title.nil? || title.strip.empty?

      result = CLIENT.query(RevAPI::CreateRevMutation, variables: {
                              description: description, title: title,
                              user_id: RevAPI::ID_TOKEN
                            })
      data = RevAPI.retrieve(result)

      data.createRev.id
    end
  end
end
