# An extension of our main module Revit
#
# @author [brwnrclse]
#
module Reivt
  # An extension of the RevAPI module
  #
  # @author [brwnrclse]
  #
  module RevAPI
    DeleteRevMutation = CLIENT.parse <<-'GRAPHQL'
      mutation($id: ID!) {
        deleteRev(id: $id) {
          id
        }
      }
    GRAPHQL

    # API call to deleteRev
    # @param id [String] The unique identifier of the Rev
    #
    # @return [String, RevAPI::GraphQLValidationError] The id of the deleted Rev
    #                                                   or an error
    #
    def self.delete_rev(id)
      if id.length < 25
        raise Reivt::GraphQLValidationException, 'Missing id to delete'
      end

      result = CLIENT.query(RevAPI::DeleteRevMutation, variables: { id: id })
      data = RevAPI.retrieve(result)

      data.deleteRev.id
    end
  end
end
