# An extension of the main module, Revit
#
# @author [brwnrclse]
#
module Reivt
  # An extension of the RevAPI module
  #
  # @author [brwnrclse]
  #
  module RevAPI
    CreateUserMutation = CLIENT.parse <<-'GRAPHQL'
      mutation($auth0_id: String!) {
        createUser(authProvider:{auth0: {idToken: $auth0_id}}) {
          id
        }
      }
    GRAPHQL

    # Authenticate the user against the api to receive a user id
    # @param id [String] The users's id from Auth0
    #
    # @return [String] The user's id in the rev api
    #
    def self.create_user(auth0_id)
      result = CLIENT.query(RevAPI::CreateUserMutation,
                            variables: { auth0_id: auth0_id })
      data = RevAPI.retrieve(result)

      data.createUser.id
    end
  end
end
