# An extension of the main module, Revit
#
# @author [brwnrclse]
#
module Reivt
  # An extension of the RevAPI module
  #
  # @author [brwnrclse]
  #
  module RevAPI
    SigninMutation = CLIENT.parse <<-'GRAPHQL'
      mutation($auth0_id: String!) {
        signinUser(auth0:{idToken: $auth0_id}) {
          user {
            id
          }
        }
      }
    GRAPHQL

    # Authenticate the user against the api to receive a user id
    # @param id [String] The users's id from Auth0
    #
    # @return [String] The user's id in the rev api
    #
    def self.signin_user(auth0_id)
      result = CLIENT.query(RevAPI::SigninMutation,
                            variables: { auth0_id: auth0_id })

      if result.data.nil?
        nil
      else
        data = RevAPI.retrieve(result)

        data.signinUser.user.id
      end
    end
  end
end
