require 'paint'

# An extension of our main module
#
# @author [brwnrclse]
#
module Reivt
  # Custom errors for dealing with repos in revit
  #
  # @author [bwrnrclse]
  #
  class BaemptyException < IOError
    def initialize(msg = 'Bare or Empty repo passed!')
      msg = "BaemptyException:\n" + msg + "\nVisit here for more info => " \
            "#{Paint['link.vaemoi.co/revitbaempty', :yellow]}"
      super(msg)
    end
  end

  # Custom errors for dealing with graphql in revit
  #
  # @author [bwrnrclse]
  #
  class GraphQLDataException < IOError
    def initialize(msg = 'Error in GraphQL API request!')
      msg = "GraphQLDataException:\n" + msg + "\nVisit her for more info => " \
           "#{Paint['link.vaemoi.co/revitgqde', :yellow]}"
      super(msg)
    end
  end

  # Custom errors for dealing with graphql in revit
  #
  # @author [bwrnrclse]
  #
  class GraphQLValidationException < IOError
    def initialize(msg = 'Error in GraphQL Validation!')
      msg = "GraphQLValidationException:\n" + msg + "\nVisit here for more " \
          "info => #{Paint['link.vaemoi.co/revitgqve', :yellow]}"
      super(msg)
    end
  end

  # Custom error for dealing with users who aren't logged in
  #
  # @author [firaga]
  #
  class LoginException < StandardError
    def initialize
      msg = 'LoginException: Run ' + Paint['revit login', :yellow] + ' first.'
      super(msg)
    end
  end
end
